var SSHShellData = {};

function sshShellCheckPort() {
  var portState = false;
  var port = parseInt(jQuery.trim(jQuery('#sshshell_manager_port').val()), 10);
  if (isNaN(port)) {
    jQuery('#sshshell_manager_port').val('');
    return portState;
  } else {
    jQuery('#sshshell_manager_port').val(port);
  }
  // if((port>65535) || (port<1)){
  if (port < 1024) {
    jQuery('#sshshell_manager_port').attr('class', 'unas_input_error');
    jQuery('#sshshell_manager_port_warning').attr('class', 'unas_icon_error');
    jQuery('#sshshell_manager_port_warning').attr('title', '* ' + UNAS._('Port must >= 1024'));
    return portState;
  } else {
    jQuery.ajax({
      url: "/apps/sshshell/includes/index.php",
      type: "POST",
      async: false,
      timeout: 20000,
      contentType: "application/json;",
      dataType: 'json',
      data: JSON.stringify({
        port: port,
        action: 'checkport'
      }),
      success: function(data) {
        if (data.status === 1) {
          jQuery('#sshshell_manager_port_warning').attr('class', '');
          jQuery('#sshshell_manager_port_warning').attr('title', '');
          jQuery('#sshshell_manager_port').attr('class', 'unas_input');
          portState = true;
        } else if (data.status === 0) {
          jQuery('#sshshell_manager_port').attr('class', 'unas_input_error');
          jQuery('#sshshell_manager_port_warning').attr('class', 'unas_icon_error');
          jQuery('#sshshell_manager_port_warning').attr('title', '* ' + UNAS._('Port has been used'));
        } else {
          jQuery('#sshshell_manager_port').attr('class', 'unas_input');
          jQuery('#sshshell_manager_port_warning').attr('class', '');
          jQuery('#sshshell_manager_port_warning').attr('title', '');
          portState = true;
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        //alert(textStatus);
      }
    });
  }
  return portState;
}

function getSshShellStatus() {
  jQuery('#sshshell_manager_waiting_content').attr("style", "display:block");
  jQuery('#sshshell_manager_waiting_logo').attr("style", "display:block");
  jQuery.ajax({
    url: "/apps/sshshell/includes/index.php",
    type: "POST",
    dataType: 'json',
    contentType: "application/json;",
    data: JSON.stringify({
      action: "getshellinaboxconf"
    }),
    timeout: 20000,
    async: true,
    success: function(data) {
      jQuery('#sshshell_main_enable_reverse_proxy_check').attr("oldvalue", data.reverseproxy);
      jQuery('#sshshell_manager_port').val(data.shellinaboxport);
      if (data.shellinaboxstate == 1) {
        jQuery('#sshshell_manager_enable').prop('checked', true);
        jQuery('#sshshell_manager_enable').attr('oldvalue', 1);
        jQuery('#sshshell_manager_port').attr("oldvalue", data.shellinaboxport);
        jQuery("#sshshell_open_terminal").attr('class', "unas_button_content");
      } else {
        jQuery('#sshshell_manager_enable').prop('checked', false);
        jQuery('#sshshell_manager_enable').attr('oldvalue', 0);
        jQuery('#sshshell_manager_port').attr("oldvalue", data.shellinaboxport);
        jQuery("[name='sshshell_manager_input']").attr('disabled', true);
        jQuery("#sshshell_open_terminal").attr('class', "unas_button_content_disabled");
      }
      if (data.reverseproxy == 1) {
        jQuery('#sshshell_main_enable_reverse_proxy_check').prop('checked', true);
      } else {
        jQuery('#sshshell_main_enable_reverse_proxy_check').prop('checked', false);
      }

      SSHShellData = data;
      jQuery.ajax({
        url: "/apps/uanywhere/includes/services_uanywhere.php",
        type: "POST",
        async: true,
        data: {
          "action": "getuanywherestatus"
        },
        dataType: 'json',
        timeout: 60000,
        success: function(data) {
          if (data.domain == "") {
            var sshshell_proxy_url = window.location.origin + '/webssh/';
          } else {
            var sshshell_proxy_url = 'http://' + data.subdomain + '.' + data.domain + '/webssh/';
          }
          jQuery('#sshshell_main_extranet_url').attr("href", sshshell_proxy_url);
          jQuery("#sshshell_main_extranet_url").html(sshshell_proxy_url).on('click', function() {
            var href = jQuery(this).attr('href');
            openSShshellbox(href);
          });
          sshShellCheckSubmit();
        }
      });
      jQuery('#sshshell_manager_waiting_content').attr("style", "display:none");
      jQuery('#sshshell_manager_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
      jQuery('#sshshell_manager_waiting_content').attr("style", "display:none");
      jQuery('#sshshell_manager_waiting_logo').attr("style", "display:none");
    }
  });
}

function openSShshellbox(href) {
  jQuery('#jv-sshshellbox').fadeIn();
  var iframe = document.createElement('iframe');
  iframe.id = 'jv-sshshellcontent';
  iframe.scrolling = "no";
  iframe.width = "100%";
  iframe.height = "100%";
  iframe.src = href;
  jQuery('#jv-sshshellbox').append(iframe);
}

function closeSShshellbox() {
  jQuery('#jv-sshshellcontent').remove();
  jQuery('#jv-sshshellbox').fadeOut();
}

function GenerateCurrentConfig() {
  var shellinaboxstate = jQuery('#sshshell_manager_enable').prop('checked') ? 1 : 0;
  var shellinaboxport = jQuery('#sshshell_manager_port').val();
  var reverseproxy = jQuery('#sshshell_main_enable_reverse_proxy_check').prop('checked') ? 1 : 0;
  return {
    "shellinaboxport": shellinaboxport,
    "shellinaboxstate": shellinaboxstate,
    'reverseproxy': reverseproxy
  };
}

function sshShellCheckSubmit() {
  if (jQuery('#sshshell_manager_enable').prop('checked')) {
    if (sshShellCheckPort()) {
      if (JSON.stringify(SSHShellData) == JSON.stringify(GenerateCurrentConfig())) {
        jQuery('#sshshell_manager_apply').attr('class', "unas_button_disabled");
      } else {
        jQuery('#sshshell_manager_apply').attr('class', "unas_button");
      }
    } else {
      jQuery('#sshshell_manager_apply').attr('class', "unas_button_disabled");
    }
  } else {
    if (JSON.stringify(SSHShellData) == JSON.stringify(GenerateCurrentConfig())) {
      jQuery('#sshshell_manager_apply').attr('class', "unas_button_disabled");
    } else {
      jQuery('#sshshell_manager_apply').attr('class', "unas_button");
    }
  }
}

function submitSshShellApply() {
  if (jQuery('#sshshell_manager_apply').attr('class') == 'unas_button_disabled') {
    return false;
  }
  jQuery('#sshshell_manager_waiting_content').attr("style", "display:block");
  jQuery('#sshshell_manager_waiting_logo').attr("style", "display:block");
  var reverseproxy = jQuery('#sshshell_main_enable_reverse_proxy_check').prop('checked') ? 1 : 0;
  var port = jQuery('#sshshell_manager_port').val();
  if (jQuery('#sshshell_manager_enable').prop('checked')) {
    jQuery.ajax({
      url: "/apps/sshshell/includes/index.php",
      type: "POST",
      data: JSON.stringify({
        "reverseproxy": reverseproxy,
        "port": port,
        "action": "enable_shellinabox"
      }),
      timeout: 20000,
      contentType: "application/json;",
      dataType: 'json',
      async: true,
      success: function(data) {
        getSshShellStatus();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        //alert(textStatus);
        jQuery('#sshshell_manager_waiting_content').attr("style", "display:none");
        jQuery('#sshshell_manager_waiting_logo').attr("style", "display:none");
      }
    });
  } else {
    jQuery.ajax({
      url: "/apps/sshshell/includes/index.php",
      type: "POST",
      data: JSON.stringify({
        "reverseproxy": reverseproxy,
        "port": port,
        "action": 'disable_shellinabox'
      }),
      timeout: 20000,
      dataType: 'json',
      contentType: "application/json;",
      async: true,
      success: function(data) {
        getSshShellStatus();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        //alert(textStatus);
        jQuery('#sshshell_manager_waiting_content').attr("style", "display:none");
        jQuery('#sshshell_manager_waiting_logo').attr("style", "display:none");
      }
    });
  }
}

function sshShellOpenTerminal() {
  if (jQuery('#sshshell_open_terminal').attr('class') == 'unas_button_content_disabled')
    return false;
  //var hostn = window.location.host;
  var hostn = window.location.hostname; //do not include port
  url = 'https://' + hostn + ':' + getCurrentPort();
  // window.open(url, '_blank');
  openSShshellbox(url);
}

function getCurrentPort() {
  var port = '';
  jQuery.ajax({
    url: "/apps/sshshell/includes/index.php",
    type: "POST",
    async: false,
    timeout: 10000,
    dataType: 'json',
    contentType: "application/json;",
    data: JSON.stringify({
      action: 'getcurrentport'
    }),
    success: function(data) {
      port = data.shellinaboxport;
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
  return port;
}

(function() {
  jQuery('#sshshell_manager_waiting_content').attr("style", "display: block");
  jQuery('#sshshell_manager_waiting_logo').attr("style", "display: block");
  getSshShellStatus();
  jQuery('#sshshell_manager_enable').click(function() {
    if (jQuery('#sshshell_manager_enable').prop('checked') == false) {
      jQuery("[name='sshshell_manager_input']").attr('disabled', true);
    } else {
      jQuery("[name='sshshell_manager_input']").attr('disabled', false);
    }
    sshShellCheckSubmit();
  });
  jQuery('#sshshell_main_enable_reverse_proxy_check').change(function() {
    sshShellCheckSubmit();
  });
  jQuery('#sshshell_manager_port').keyup(function() {
    sshShellCheckSubmit();
  });
})();
